<template>
  <div class="chart-wrapper">
    <div class="chart-container"></div>
  </div>
</template>

<script>
import * as d3 from 'd3'
import Highcharts from 'highcharts'
import UtilsService from '@/services/UtilsService'
export default {
  props: {
    series: {
      type: Array,
      required: true,
    },
    title: {
      type: String,
      default: '',
    },
    suffix: {
      type: String,
      default: '',
    },
    colors: {
      type: Array,
      default() {
        return [
          // Default Highcharts colors
          '#7cb5ec',
          '#434348',
          '#90ed7d',
          '#f7a35c',
          '#8085e9',
          '#f15c80',
          '#e4d354',
          '#2b908f',
          '#f45b5b',
          '#91e8e1',
        ]
      },
    },
    labels: {
      type: Boolean,
      default: false,
    },
    height: {
      type: String,
      default: undefined,
    },
    width: {
      type: String,
      default: undefined,
    },
  },
  data() {
    return {}
  },
  computed: {},
  watch: {
    series: {
      handler: 'drawChart',
      immediate: false,
    },
    labels: {
      handler: 'toggleLabels',
      immediate: false,
    },
  },
  methods: {
    toggleLabels() {
      if (this.labels) {
        d3.select(this.$el)
          .selectAll('.highcharts-data-label,.highcharts-stack-labels')
          .style('display', null)
      } else {
        d3.select(this.$el)
          .selectAll('.highcharts-data-label,.highcharts-stack-labels')
          .style('display', 'none')
      }
    },
    drawChart() {
      const self = this
      Highcharts.setOptions({
        colors: this.colors,
      })
      const hasTwoLevels =
        this.series[0] &&
        // eslint-disable-next-line no-prototype-builtins
        this.series[0].hasOwnProperty('sub') &&
        this.series[0].sub !== undefined
      const dataToDraw = d3
        .nest()
        .key((o) => (hasTwoLevels ? o.sub : o.name))
        .entries(this.series)
        .map((o) => ({
          name: o.key,
          data: o.values,
          y: d3.sum(o.values, (d) => d.y),
        }))
      const $container = d3.select(this.$el).select('.chart-container').node()
      // const colors = Highcharts.getOptions().colors
      const wholeConfig = {
        chart: {
          type: 'pie',
          height: this.height,
          width: this.width,
        },
        title: {
          text: '',
        },
        plotOptions: {
          pie: {
            shadow: false,
            center: ['50%', '50%'],
            innerSize: '60%',
            colors: this.colors,
            showInLegend: true,
          },
        },
        tooltip: {
          valueSuffix: this.suffix,
          pointFormatter() {
            return `<span style="color:${this.color}">${
              this.name
            }</span>: <b>${UtilsService.formatNumber(this.y, 2)}${
              self.suffix
            }</b><br/>`
          },
        },
        series: [
          {
            name: '',
            data: dataToDraw,
            colorByPoint: true,
            dataLabels: {
              enabled: true,
              formatter() {
                return this.point.y > 1
                  ? `${UtilsService.formatNumber(this.point.y)}${self.suffix}`
                  : null
              },
              color: '#ffffff',
              distance: -30,
            },
          },
        ],
        responsive: {
          rules: [
            {
              condition: {
                maxWidth: 400,
              },
              chartOptions: {
                series: [
                  {},
                  {
                    id: 'versions',
                    dataLabels: {
                      enabled: false,
                    },
                  },
                ],
              },
            },
          ],
        },
      }
      // Create the chart
      Highcharts.chart($container, wholeConfig)
      this.toggleLabels()
    },
  },
  render(createElement) {
    return createElement('div')
  },
}
</script>

<style></style>
